/*--------------------------------------------------------------*\
		module	:	SFT.c
		purpose :	ȒPt@C] C
		author	:	_@ Kengo Jinno
		create	:	2011/02/21
		update	:	2011/04/19
\*--------------------------------------------------------------*/

#include	"PCH.h"
#include	"SFT.h"
#include	"HOOK.h"
#include	"MySocket.h"
#include	"Progress.h"
#include	"ToolTip.h"

#include	"resource.h"

#define		VERSION		_T("1.0(32)")

static	const	TCHAR	szFormWndClass[] = _T("SftFormWndClass");	/*	EBhENX	*/

/* INIt@C̃ZNVEGg[	*/
static	const	TCHAR	lpszProfileSection[] = _T("SimpleFileTransfer");
static	const	TCHAR	lpszProfileVersionEntry[] = _T("Version");
static	const	TCHAR	lpszProfileSendToEntry[] = _T("SendTo");
static	const	TCHAR	lpszProfilePortEntry[] = _T("Port");
static	const	TCHAR	lpszProfileInitDirEntry[] = _T("InitDir");

/*	_CAOvV[W	*/
static	BOOL	CALLBACK	FormWndProc( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam );

/*	EBhE쐬	*/
static	HWND	CreateFormWnd( HINSTANCE hInstance, LPCTSTR lpszTemplate, HWND hWndOwner )
{
	WNDCLASS	wc;
	
	if( !GetClassInfo( hInstance, szFormWndClass, &wc ) ) {
		WNDCLASS	wc;
		wc.style = CS_DBLCLKS;
		wc.lpfnWndProc = DefDlgProc;
		wc.cbClsExtra = 0;
		wc.cbWndExtra = DLGWINDOWEXTRA+SFT_EXTRA_BYTES;
		wc.hInstance = hInstance;
		wc.hIcon = LoadIcon( hInstance, MAKEINTRESOURCE( IDI_MAIN_ICON ) );
		wc.hCursor = LoadCursor( NULL, IDC_ARROW );
		wc.hbrBackground = NULL;
		wc.lpszMenuName = NULL;
		wc.lpszClassName = szFormWndClass;
		if( !RegisterClass( &wc ) ) {
			return NULL;
		}
	}
	return CreateDialogParam( hInstance, lpszTemplate, NULL, (DLGPROC)FormWndProc, (LPARAM)hInstance );
}

/*	INIt@C̓ǂݍ	*/
static	void	NEAR	ReadProfile( NpSftInfo p, LPCTSTR lpszFile )
{
	GetPrivateProfileString( lpszProfileSection, lpszProfileSendToEntry, _T(""), p->SocketInfo.szSendTo, countof(p->SocketInfo.szSendTo), lpszFile );
	p->SocketInfo.uPort = GetPrivateProfileInt( lpszProfileSection, lpszProfilePortEntry, 62801, lpszFile );	/*	HD62801 -> HD64180	*/
	GetPrivateProfileString( lpszProfileSection, lpszProfileInitDirEntry, _T(""), p->szInitialDir, countof(p->szInitialDir), lpszFile );
}

static	BOOL	NEAR	WritePrivateProfileInt( LPCTSTR lpszSection, LPCTSTR lpszKey, DWORD dwValue, LPCTSTR lpszFile )
{
	TCHAR	buff[256];
	static	const	TCHAR	szFmt[] = _T("%ld");
	wsprintf( buff, szFmt, dwValue );
	return WritePrivateProfileString( lpszSection, lpszKey, buff, lpszFile );
}

/*	INIt@C̏	*/
static	void	NEAR	WriteProfile( NpSftInfo p, LPCTSTR lpszFile )
{
	static	const	TCHAR	szVersion[] = VERSION;
	WritePrivateProfileString( lpszProfileSection, lpszProfileVersionEntry, szVersion, lpszFile );
	WritePrivateProfileString( lpszProfileSection, lpszProfileSendToEntry, p->SocketInfo.szSendTo, lpszFile );
//	WritePrivateProfileInt( lpszProfileSection, lpszProfilePortEntry, p->SocketInfo.uPort, lpszFile );
	WritePrivateProfileString( lpszProfileSection, lpszProfileInitDirEntry, p->szInitialDir, lpszFile );
}

static	void	NEAR	ShowTitleBar( HWND hDlg )
{
	NpSftInfo	p = GetSftInfo( hDlg );
	TCHAR	buff[80], fmt[80], mode[40];
	LoadString( p->hInstance, IDS_APP_TITLE, fmt, countof(fmt) );
	mode[0] = _T('\0');
	if( p->nMode == SFT_MODE_SEND ) {
		LoadString( p->hInstance, IDS_APP_FMT_TITLE, fmt, countof(fmt) );
		LoadString( p->hInstance, IDS_MODE_SEND, mode, countof(mode) );
	} else if( p->nMode == SFT_MODE_RECV ) {
		LoadString( p->hInstance, IDS_APP_FMT_TITLE, fmt, countof(fmt) );
		LoadString( p->hInstance, IDS_MODE_RECV, mode, countof(mode) );
	}
	wsprintf( buff, fmt, mode );
	SetWindowText( hDlg, buff );
}

static	void	NEAR	EnableControl( HWND hDlg )
{
	NpSftInfo	p = GetSftInfo( hDlg );
	BOOL	bEnable;
	int		nMsg;
	TCHAR	btn[ 80 ];
	if( !IsOpenedMySocket( &(p->SocketInfo) ) ) {
		/*	@\I	*/
		EnableWindow( GetDlgItem( hDlg, IDC_RADIO_MODE_SEND ), TRUE );
		EnableWindow( GetDlgItem( hDlg, IDC_RADIO_MODE_RECV ), TRUE );
		/*		*/
		EnableWindow( GetDlgItem( hDlg, IDC_EDIT_SENDTO ), p->nMode == SFT_MODE_SEND );
		EnableWindow( GetDlgItem( hDlg, IDC_BTN_FILE ), p->nMode == SFT_MODE_SEND );
		/*	Jn{^	*/
		LoadString( p->hInstance, IDS_BTN_START, btn, countof(btn) );
		SetDlgItemText( hDlg, IDC_BTN_START, btn );
		if( p->nMode == SFT_MODE_RECV ) {
			bEnable = TRUE;
			nMsg = IDS_MSG_START;
		} else if( p->nMode == SFT_MODE_SEND ) {
			bEnable = ( GetWindowTextLength( GetDlgItem( hDlg, IDC_EDIT_SENDTO ) ) > 0 );
			bEnable = bEnable && ( p->szFilePath[0] != _T('\0') );
			nMsg = bEnable ? IDS_MSG_START : IDS_MSG_SEND_SELECT;
		} else {
			bEnable = FALSE;
			nMsg = IDS_MSG_SELECT;
		}
		EnableWindow( GetDlgItem( hDlg, IDC_BTN_START ), bEnable );
		/*	bZ[W	*/
		LoadString( p->hInstance, nMsg, btn, countof(btn) );
		SetDlgItemText( hDlg, IDC_STATIC_MSG, btn );
		/*	vOX	*/
		p->nProgressPos = ResetProgressPos( hDlg );
		
		if( p->hFile != INVALID_HANDLE_VALUE ) {
			CloseHandle( p->hFile );
			p->hFile = INVALID_HANDLE_VALUE;
		}
	} else {
		WORD	id;
		/*	@\I	*/
		EnableWindow( GetDlgItem( hDlg, IDC_RADIO_MODE_SEND ), FALSE );
		EnableWindow( GetDlgItem( hDlg, IDC_RADIO_MODE_RECV ), FALSE );
		/*		*/
		EnableWindow( GetDlgItem( hDlg, IDC_EDIT_SENDTO ), FALSE );
		EnableWindow( GetDlgItem( hDlg, IDC_BTN_FILE ), FALSE );
		/*	Jn{^	*/
		LoadString( p->hInstance, IDS_BTN_STOP, btn, countof(btn) );
		SetDlgItemText( hDlg, IDC_BTN_START, btn );
		/*	bZ[W	*/
		if( p->SocketInfo.bListen ) {
			/*	T[o	*/
			if( !IsExistClientMySocket( &(p->SocketInfo) ) ) {
				/*	ҋ@	*/
				id = IDS_MSG_RECV_WAITING;
				if( p->hFile != INVALID_HANDLE_VALUE ) {
					CloseHandle( p->hFile );
					p->hFile = INVALID_HANDLE_VALUE;
				}
				p->nProgressPos = ResetProgressPos( hDlg );
			} else if( p->hFile == INVALID_HANDLE_VALUE ) {
				id = IDS_MSG_RECV_INFO;
			} else {
				id = IDS_MSG_RECV_FILE;
			}
		} else {
			if( p->SocketInfo.nClientState == STATE_CLIENT_NONE ) {
				id = IDS_MSG_SEND_CONNECT;
			} else if( p->SocketInfo.nClientState == STATE_CLIENT_CONN ) {
				id = IDS_MSG_SEND_INFO;
			} else if( p->SocketInfo.nClientState == STATE_CLIENT_INFO ) {
				id = IDS_MSG_SEND_INFO;
			} else if( p->SocketInfo.nClientState == STATE_CLIENT_CONTENT ) {
				id = IDS_MSG_SEND_FILE;
			}
		}
		LoadString( p->hInstance, id, btn, countof(btn) );
		SetDlgItemText( hDlg, IDC_STATIC_MSG, btn );
	}
}

/*	WM_INITDIALOG	*/
static	BOOL	InitDialogProc( HWND hDlg, HINSTANCE hInstance )
{
	NpSftInfo	p;
	RECT	rect;
	HMENU	hSysMenu;
	
	/*	PCH.cɂ鏉֐	*/
	CheckOsVersion();
	CheckComctl32DllVersion();
	
	p = (NpSftInfo)LocalAlloc( LPTR, sizeof(SftInfo) );
	if( p == NULL ) {
		PostMessage( hDlg, WM_CLOSE, 0, 0 );
		return FALSE;
	}
	SetSftInfo( hDlg, p );
	
	p->hInstance = hInstance;
	
	p->hLargeIcon = LoadIcon( hInstance, MAKEINTRESOURCE( IDI_MAIN_ICON ) );
	p->hSmallIcon = (HICON)LoadImage( hInstance, MAKEINTRESOURCE(IDI_MAIN_ICON), IMAGE_ICON, 16, 16, 0 );
	SendMessage( hDlg, WM_SETICON, ICON_BIG, (LPARAM)p->hLargeIcon );
	SendMessage( hDlg, WM_SETICON, ICON_SMALL, (LPARAM)p->hSmallIcon );
	
	LoadString( hInstance, IDS_APP_TITLE, p->szAppTitle, countof(p->szAppTitle) );
	p->nMode = SFT_MODE_NONE;
	
	{	/*	INIt@Č	*/
		TCHAR	buff[_MAX_PATH];
		LPSTR	q, r, s;
		static	const	TCHAR	szExtension[] = _T(".ini");
		GetModuleFileName( p->hInstance, buff, countof(buff) );
		q = r = s = buff;
		while( *r != _T('\0') ) {
#ifdef	WIN32
			if( IsDBCSLeadByte( *r ) ) {
#else
			if( iskanji( *r ) && iskanji2( *(r+1) ) ) {
			/*	3.1ȂIsDBCSLeadByte()Ă񂾂	*/
#endif
				r++;
			} else if( *r == _T('.') ) {
				s = r;	//	Ō'.'w
			} else if( *r == _T('\\') ) {
				q = r;	//	Ō'\\'w
			}
			r++;
		}
#ifdef	WIN32
		{
			WIN32_FIND_DATA	wfd;
			HANDLE	h = FindFirstFile( buff, &wfd );
			if( h != INVALID_HANDLE_VALUE ) {
				FindClose( h );
				/*	t@Cǉ	*/
				*(q+1) = _T('\0');
				lstrcat( buff, wfd.cFileName );
				s = r = q;
				while( *r != _T('\0') ) {
					if( IsDBCSLeadByte( *r ) ) {
						r++;
					} else if( *r == _T('.') ) {
						s = r;	//	Ō'.'w
					}
					r++;
				}
			}
		}
#endif
		/*	INIt@C	*/
		lstrcpy( p->szProfile, buff );
		p->szProfile[ s-buff ] = _T('\0');
		lstrcat( p->szProfile, szExtension );
	}
	p->szInitialDir[0] = _T('\0');
	p->szFilePath[0] = _T('\0');
	p->szFileName[0] = _T('\0');
	p->szSaveFilePath[0] = _T('\0');
	
	p->lpPathSetDlgItemPath = NULL;
	p->hInstShlWapiDll = LoadLibrary( _T("shlwapi.dll") );
	if( p->hInstShlWapiDll != NULL ) {
#ifdef UNICODE
		LPCTSTR	lpszFuncName = _T("PathSetDlgItemPathW");
#else
		LPCTSTR	lpszFuncName = _T("PathSetDlgItemPathA");
#endif
		p->lpPathSetDlgItemPath = (LP_FUNC_PATHSETDLGITEMPATH)GetProcAddress( p->hInstShlWapiDll, lpszFuncName );
		/*
			Win98ȍ~Ŏg(͂)
		*/
	}
	
	/*	\Pbg	*/
	InitMySocket( hDlg, &(p->SocketInfo) );
	
	p->hFile = INVALID_HANDLE_VALUE;
	p->dwSizeRemain = 0;
	p->dwSizeTotal = 0;
	
	/*	INIt@C̓ǂݍ	*/
	ReadProfile( p, p->szProfile );
	
	
	/*		*/
	SetDlgItemText( hDlg, IDC_EDIT_SENDTO, p->SocketInfo.szSendTo );
	
	/*	t@C	*/
	SetDlgItemText( hDlg, IDC_STATIC_FILE_NAME, p->szFileName );
	
	/*	VXej[	*/
	hSysMenu = GetSystemMenu( hDlg, FALSE );
	if( hSysMenu != NULL ) {
		TCHAR	buff[80];
		
		RemoveMenu( hSysMenu, SC_MAXIMIZE, MF_BYCOMMAND );
		
		AppendMenu( hSysMenu, MF_ENABLED|MF_SEPARATOR, (UINT)NULL, NULL );	/*	Zp[^	*/
		
		if( LoadString( p->hInstance, ID_ABOUTBOX, buff, countof(buff) ) ) {
			AppendMenu( hSysMenu, MF_ENABLED|MF_STRING, ID_ABOUTBOX, buff );
		}
	}
	
	/*	c[`bv	*/
	{
		ToolTipDataType	ti[] = {
			{ IDC_RADIO_MODE_SEND,  IDS_TIPS_RADIO_MODE_SEND  },
			{ IDC_RADIO_MODE_RECV,  IDS_TIPS_RADIO_MODE_RECV  },
			{ IDC_EDIT_SENDTO,      IDS_TIPS_EDIT_SENDTO      },
			{ IDC_BTN_FILE,         IDS_TIPS_BTN_FILE         },
			{ IDC_STATIC_FILE_NAME, IDS_TIPS_STATIC_FILE_NAME },
			{ IDC_STATIC_MSG,       IDS_TIPS_STATIC_MSG       },
			{ IDC_PROGRESS_PROCESS, IDS_TIPS_PROGRESS_PROCESS },
			{ IDC_BTN_START,        IDS_TIPS_BTN_START        },
			{ IDC_BTN_QUIT,         IDS_TIPS_BTN_QUIT         },
		};
		p->hWndToolTip = CreateMyToolTip( hDlg, ti, countof(ti), gbIe3Later, TRUE );
	}
	
	/*	bZ[WptHg	*/
	p->hFontMsg = NULL;
	{
		HFONT	hFont;
		LOGFONT	lf;
		hFont = (HFONT)SendMessage( hDlg, WM_GETFONT, 0, 0 );
		if( hFont == NULL ) {
			hFont = (HFONT)GetStockObject( SYSTEM_FONT );
		}
		GetObject( hFont, sizeof(lf), &lf );
		lf.lfWeight = 700;	/*		*/
		p->hFontMsg = CreateFontIndirect( &lf );
		SendDlgItemMessage( hDlg, IDC_STATIC_MSG, WM_SETFONT, (WPARAM)(p->hFontMsg), MAKELPARAM(TRUE,0) );
	}
	
	/*	vOXo[	*/
	InitProgressRange( hDlg );
	p->nProgressPos = ResetProgressPos( hDlg );
	
	ShowTitleBar( hDlg );
	EnableControl( hDlg );
	
	
	return TRUE;
}

/*	WM_INITMENUPOPUP	*/
static	BOOL	InitMenuPopupProc( HWND hDlg, HMENU hMenuPopup, UINT uPos, BOOL fSystemMenu )
{
	if( fSystemMenu ) {
		BOOL	flag = IsIconic( hDlg );
		EnableMenuItem( hMenuPopup, SC_RESTORE, MF_BYCOMMAND|(!flag?MF_GRAYED:0) );
		EnableMenuItem( hMenuPopup, SC_MINIMIZE, MF_BYCOMMAND|(flag?MF_GRAYED:0) );
	}
	return FALSE;
}

static	BOOL	DoFileDialog( HWND hDlg, BOOL bSave )
{
	NpSftInfo	p = GetSftInfo( hDlg );
	BOOL	ret = FALSE;
	if( p != NULL ) {
		OPENFILENAME	ofn;
		TCHAR	szExtension[_MAX_PATH], szFilter[_MAX_PATH], szFileName[_MAX_PATH];
		TCHAR	szFileTitle[_MAX_PATH];
		TCHAR	szBuff[_MAX_PATH];
		LPTSTR	pt = szFilter;
		
		GetCurrentDirectory( countof(szBuff), szBuff );
		
		LoadString( p->hInstance, IDS_FILE_FILTER, szFilter, countof(szFilter) );
		LoadString( p->hInstance, IDS_FILE_EXTENSION, szExtension, countof(szExtension) );
		while( *pt != _T('\0') ) {
			if( *pt == _T('|') ) {
				*pt = _T('\0');
			}
			pt++;
		}
		if( bSave ) {
			lstrcpy( szFileName, p->szFileName );	/*	t@C	*/
		} else {
			szFileName[0] = _T('\0');
		}
		szFileTitle[0] = _T('\0');
		ZeroMemory( &ofn, sizeof(ofn) );
		ofn.lStructSize = sizeof(ofn);
		ofn.hwndOwner = hDlg;
		ofn.hInstance = NULL;
		ofn.lpstrFilter = szFilter;
		ofn.lpstrInitialDir = ( p->szInitialDir[0] == _T('\0') ) ? NULL : p->szInitialDir;
		ofn.lpstrFile = szFileName;
		ofn.nMaxFile = countof(szFileName);
		ofn.lpstrFileTitle = szFileTitle;
		ofn.nMaxFileTitle = countof(szFileTitle);
		ofn.Flags = OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT|OFN_EXPLORER|OFN_PATHMUSTEXIST|(bSave?0:OFN_FILEMUSTEXIST);
		ofn.lpstrDefExt = szExtension;
		ofn.lCustData = 0;
		if(  bSave && GetSaveFileName( &ofn ) ||
			!bSave && GetOpenFileName( &ofn ) ) {
			if( bSave ) {
				lstrcpy( p->szSaveFilePath, ofn.lpstrFile );	/*	tpX	*/
			} else {
				lstrcpy( p->szFilePath, ofn.lpstrFile );		/*	tpX	*/
			}
			lstrcpy( p->szFileName, ofn.lpstrFileTitle );	/*	t@C	*/
			
			ret = TRUE;
			
			GetCurrentDirectory( countof(p->szInitialDir), p->szInitialDir );
		}
		/*	JgfBNg𕜊	*/
		SetCurrentDirectory( szBuff );
	}
	
	return( ret );
}

/*	WM_COMMAND	*/
static	BOOL	CommandProc( HWND hDlg, WORD wNotifyCode, WORD wID, HWND hWndCtrl )
{
	NpSftInfo	p = GetSftInfo( hDlg );
	switch( wID ) {
	case ID_ABOUTBOX:
		{
			POINT	pt;
			GetCursorPos( &pt );
			PostMessage( hDlg, WM_SYSCOMMAND, ID_ABOUTBOX, MAKELPARAM(pt.x,pt.y) );
		}
		break;
	case IDC_RADIO_MODE_SEND:
	case IDC_RADIO_MODE_RECV:
		if( p != NULL ) {
			BOOL	bChange = FALSE;
			if( IsDlgButtonChecked( hDlg, IDC_RADIO_MODE_SEND ) ) {
				if( p->nMode != SFT_MODE_SEND ) {
					p->nMode = SFT_MODE_SEND;
					bChange = TRUE;
				}
			} else if( IsDlgButtonChecked( hDlg, IDC_RADIO_MODE_RECV ) ) {
				if( p->nMode != SFT_MODE_RECV ) {
					p->nMode = SFT_MODE_RECV;
					bChange = TRUE;
				}
			}
			if( bChange ) {
				ShowTitleBar( hDlg );
				EnableControl( hDlg );
			}
		}
		break;
	case IDC_EDIT_SENDTO:
		if( p != NULL && wNotifyCode == EN_UPDATE ) {
			/*	悪ύXꂽA[Jn]{^L/	*/
			EnableControl( hDlg );
		}
		break;
	case IDC_BTN_FILE:
		if( p != NULL ) {
			if( DoFileDialog( hDlg, FALSE ) ) {
				/*	t@C\	*/
				/*	PathSetDlgItemPath() gΎg	*/
				if( p->lpPathSetDlgItemPath != NULL ) {
					(*(p->lpPathSetDlgItemPath))( hDlg, IDC_STATIC_FILE_NAME, p->szFilePath );
				} else {
					SetDlgItemText( hDlg, IDC_STATIC_FILE_NAME, p->szFileName );
				}
			}
			EnableControl( hDlg );
			return TRUE;
		}
		break;
	case IDC_BTN_START:
		if( p != NULL ) {
			if( !IsOpenedMySocket( &(p->SocketInfo) ) ) {
				if( p->nMode == SFT_MODE_SEND ) {
					/*	t@C𑗂(NCAg)	*/
					p->SocketInfo.bListen = FALSE;
					GetDlgItemText( hDlg, IDC_EDIT_SENDTO, p->SocketInfo.szSendTo, countof(p->SocketInfo.szSendTo) );
					p->SocketInfo.nClientState = STATE_CLIENT_NONE;
					if( !OpenMySocket( hDlg, &(p->SocketInfo) ) ) {
						static	const	TCHAR	szFmt[] = _T("\n(%s:%ld)");
						TCHAR	msg[256];
						TCHAR	err[256];
						int		nLen;
						nLen = LoadString( p->hInstance, IDS_OPEN_ERROR_CLI, msg, countof(msg) );
						LoadString( p->hInstance, p->SocketInfo.uErrorID, err, countof(err) );
						wsprintf( msg+nLen, szFmt, err, p->SocketInfo.dwErrorCode );
						MessageBox( hDlg, msg, p->szAppTitle, MB_APPLMODAL|MB_DEFBUTTON1|MB_ICONSTOP|MB_OK );
					} else {
						p->SocketInfo.nClientState = STATE_CLIENT_CONN;
						DoProgressStep( hDlg, PROGRESS_STEP_1 );
#ifdef	_DEBUG
						OutputDebugString( _T("Start as Client\r\n") );
#endif
					}
				} else if( p->nMode == SFT_MODE_RECV ) {
					/*	t@C󂯎(T[o)	*/
					p->SocketInfo.bListen = TRUE;
					if( !OpenMySocket( hDlg, &(p->SocketInfo) ) ) {
						static	const	TCHAR	szFmt[] = _T("\n(%s:%ld)");
						TCHAR	msg[256];
						TCHAR	err[256];
						int		nLen;
						nLen = LoadString( p->hInstance, IDS_OPEN_ERROR_SVR, msg, countof(msg) );
						LoadString( p->hInstance, p->SocketInfo.uErrorID, err, countof(err) );
						wsprintf( msg+nLen, szFmt, err, p->SocketInfo.dwErrorCode );
						MessageBox( hDlg, msg, p->szAppTitle, MB_APPLMODAL|MB_DEFBUTTON1|MB_ICONSTOP|MB_OK );
					} else {
						p->nProgressPos = ResetProgressPos( hDlg );
#ifdef	_DEBUG
						OutputDebugString( _T("Start as Server\r\n") );
#endif
					}
				}
			} else if( p->SocketInfo.bListen ) {
				/*	T[o(ҋ@M)	*/
				if( IsExistClientMySocket( &(p->SocketInfo) ) ) {
					/*	NCAgڑ	*/
					CloseClientMySocket( hDlg, &(p->SocketInfo) );
					if( p->hFile != INVALID_HANDLE_VALUE ) {
						CloseHandle( p->hFile );
						p->hFile = INVALID_HANDLE_VALUE;
						/*
							t@C폜ׂ
						*/
					}
					PostMessage( hDlg, WM_MY_RESULT_NOTIFY, IDS_RESULT_STOP, MB_ICONSTOP );
				} else {
					/*	ҋ@Ă邾	*/
					CloseMySocket( hDlg, &(p->SocketInfo) );
				}
			} else {
				/*	NCAg(M)	*/
				/*	~	*/
				CloseMySocket( hDlg, &(p->SocketInfo) );
				if( p->hFile != INVALID_HANDLE_VALUE ) {
					CloseHandle( p->hFile );
					p->hFile = INVALID_HANDLE_VALUE;
				}
				PostMessage( hDlg, WM_MY_RESULT_NOTIFY, IDS_RESULT_STOP, MB_ICONSTOP );
			}
			PostMessage( hDlg, WM_MY_SOCKET_NOTIFY, 0, 0 );
		}
		break;
	case IDC_BTN_QUIT:
		PostMessage( hDlg, WM_CLOSE, 0, 0 );
		break;
	}
	return FALSE;
}

/*	WM_SYSCOMMAND	*/
static	BOOL	SysCommandProc( HWND hDlg, UINT uCmdType, int xPos, int yPos )
{
	NpSftInfo	p = GetSftInfo( hDlg );
	uCmdType &= 0xfff0;
	if( uCmdType == ID_ABOUTBOX && p != NULL ) {
		/*	o[W	*/
		TCHAR	buff[256], msg[256];
		static	const	TCHAR	szVersion[] = VERSION;
		LoadString( p->hInstance, IDS_VERSION, buff, countof(buff) );
		wsprintf( msg, buff, p->szAppTitle, (LPCTSTR)szVersion );
		MessageBox( hDlg, msg, p->szAppTitle, MB_APPLMODAL|MB_DEFBUTTON1|MB_ICONINFORMATION|MB_OK );
		return TRUE;
	}
	return FALSE;
}

/*	WM_NOTIFY	*/
static	void	NotifyProc( HWND hDlg, LPNMHDR pnmh )
{
	NpSftInfo	p = GetSftInfo( hDlg );
	if( pnmh->code == TTN_NEEDTEXT ) {
		LPTOOLTIPTEXT	lptip = (LPTOOLTIPTEXT)pnmh;
		if( pnmh->hwndFrom == p->hWndToolTip ) {
			NeedTextMyToolTip( p->hWndToolTip, p->hInstance, lptip );
		}
	}
}

/*	WM_MY_CLIENT_MSG	*/
static	void	MyClientMsgProc( HWND hDlg, int nState, int nAnswer )
{
	NpSftInfo	p = GetSftInfo( hDlg );
	if( p != NULL ) {
		NpMySocketInfo	pInfo = &(p->SocketInfo);
		switch( nState ) {
		case STATE_CLIENT_NONE:		/*	ĂȂ	*/
			break;
		case STATE_CLIENT_CONN:		/*	connect()ĉ҂	*/
			if( nAnswer == MSG_S2C_ACK ) {
				/*	t@C𑗐M	*/
				p->hFile =  CreateFile( p->szFilePath, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL );
				if( p->hFile != INVALID_HANDLE_VALUE ) {
					DWORD	dwSizeHigh, dwSizeLow;
					MyClient2ServerMsg	msg;
					
					dwSizeLow = GetFileSize( p->hFile, &dwSizeHigh );
					
					if( dwSizeHigh > 0 ) {
						/*	ő2GBɐ	*/
						dwSizeHigh = 0;
						dwSizeLow = LONG_MAX;
					} else if( dwSizeLow > (DWORD)LONG_MAX ) {
						dwSizeLow = LONG_MAX;
					}
					p->dwSizeRemain = dwSizeLow;
					p->dwSizeTotal = dwSizeLow;
					
					MD5Init( &(p->md5context) );
					
					ZeroMemory( &msg, sizeof(msg) );
					msg.uMsgBody.sFileInfo.dwSizeHigh = dwSizeHigh;
					msg.uMsgBody.sFileInfo.dwSizeLow = dwSizeLow;
					lstrcpy( msg.uMsgBody.sFileInfo.szFileName, p->szFileName );
					SendC2sMsg( pInfo->hSocket, &msg, MSG_C2S_FILEINFO );
					pInfo->nClientState = STATE_CLIENT_INFO;
					DoProgressStep( hDlg, PROGRESS_STEP_2 );
					p->nProgressPos = 0;
				} else {
					TCHAR	msg[256];
					CloseMySocket( hDlg, pInfo );
					pInfo->nClientState = STATE_CLIENT_NONE;
					LoadString( p->hInstance, IDS_ERROR_CREATE_FILE, msg, countof(msg) );
					MessageBox( hDlg, msg, p->szAppTitle, MB_APPLMODAL|MB_DEFBUTTON1|MB_ICONSTOP|MB_OK );
				}
			} else {
				/*	T[oڑۂ(M)	*/
				TCHAR	msg[256];
				CloseMySocket( hDlg, pInfo );
				pInfo->nClientState = STATE_CLIENT_NONE;
				LoadString( p->hInstance, IDS_CONN_ERROR, msg, countof(msg) );
				MessageBox( hDlg, msg, p->szAppTitle, MB_APPLMODAL|MB_DEFBUTTON1|MB_ICONSTOP|MB_OK );
			}
			PostMessage( hDlg, WM_MY_SOCKET_NOTIFY, 0, 0 );
			break;
		case STATE_CLIENT_INFO:		/*	t@C𑗂ĉ҂	*/
		case STATE_CLIENT_CONTENT:	/*	t@C̓e𑗐M	*/
			if( nAnswer == MSG_S2C_ACK ) {
				if( p->dwSizeRemain > 0 ) {
					/*	t@Ce𑗐M	*/
					DWORD	dwSize = p->dwSizeRemain;
					DWORD	dwRead = 0;
					MyClient2ServerMsg	msg;
					ZeroMemory( &msg, sizeof(msg) );
					if( dwSize > sizeof(msg.uMsgBody.sFileContent.data) ) {
						dwSize = sizeof(msg.uMsgBody.sFileContent.data);
					}
					ReadFile( p->hFile, msg.uMsgBody.sFileContent.data, dwSize, &dwRead, NULL );
					msg.uMsgBody.sFileContent.wSize = dwRead;
					p->dwSizeRemain -= dwRead;
					SendC2sMsg( pInfo->hSocket, &msg, MSG_C2S_CONTENT );
					
					MD5Update( &(p->md5context), (unsigned char *)(msg.uMsgBody.sFileContent.data), dwRead );
					
					p->nProgressPos = SetProgressPos( hDlg, p->nProgressPos, p->dwSizeTotal, p->dwSizeRemain );
					
					if( nState == STATE_CLIENT_INFO ) {
						pInfo->nClientState = STATE_CLIENT_CONTENT;
						PostMessage( hDlg, WM_MY_SOCKET_NOTIFY, 0, 0 );
					}
				} else {
					/*	I	*/
					FILETIME	ft;
					SYSTEMTIME	st;
					MyClient2ServerMsg	msg;
					
					GetFileTime( p->hFile, NULL, NULL, &ft );
					CloseHandle( p->hFile );
					p->hFile = INVALID_HANDLE_VALUE;
					
					FileTimeToSystemTime( &ft, &st );
					
					ZeroMemory( &msg, sizeof(msg) );
					msg.uMsgBody.sFileAttr.wYear = st.wYear;
					msg.uMsgBody.sFileAttr.wMonth = st.wMonth;
					msg.uMsgBody.sFileAttr.wDayOfWeek = st.wDayOfWeek;
					msg.uMsgBody.sFileAttr.wDay = st.wDay;
					msg.uMsgBody.sFileAttr.wHour = st.wHour;
					msg.uMsgBody.sFileAttr.wMinute = st.wMinute;
					msg.uMsgBody.sFileAttr.wSecond = st.wSecond;
					msg.uMsgBody.sFileAttr.wMilliseconds = st.wMilliseconds;
					
					MaxProgressPos( hDlg );
					
#ifdef	_DEBUG
					if( GetKeyState(VK_SHIFT) & 0x8000 ) {
						MD5Update( &(p->md5context), (unsigned char *)(&msg.uMsgBody.sFileAttr), sizeof(msg.uMsgBody.sFileAttr) );
					}
#endif
					MD5Final( msg.uMsgBody.sFileAttr.md5, &(p->md5context) );
					
					SendC2sMsg( pInfo->hSocket, &msg, MSG_C2S_FILEATTR );
					pInfo->nClientState = STATE_CLIENT_ATTR;
				}
			} else {
				TCHAR	msg[256];
				CloseMySocket( hDlg, pInfo );
				if( p->hFile != INVALID_HANDLE_VALUE ) {
					CloseHandle( p->hFile );
					p->hFile = INVALID_HANDLE_VALUE;
				}
				if( nState == STATE_CLIENT_INFO ) {
					/*	T[oۂ	*/
					LoadString( p->hInstance, IDS_INFO_ERROR, msg, countof(msg) );
				} else {
					/*	T[oŃG[	*/
					LoadString( p->hInstance, IDS_ERROR_RECEIVE, msg, countof(msg) );
				}
				MessageBox( hDlg, msg, p->szAppTitle, MB_APPLMODAL|MB_DEFBUTTON1|MB_ICONSTOP|MB_OK );
				pInfo->nClientState = STATE_CLIENT_NONE;
				PostMessage( hDlg, WM_MY_SOCKET_NOTIFY, 0, 0 );
			}
			break;
		case STATE_CLIENT_ATTR:		/*	𑗂ĉ҂	*/
			CloseMySocket( hDlg, pInfo );
			if( nAnswer == MSG_S2C_ACK ) {
				/*	ŏI	*/
				PostMessage( hDlg, WM_MY_RESULT_NOTIFY, IDS_MSG_SEND_COMPLETE, MB_ICONINFORMATION );
			} else {
				PostMessage( hDlg, WM_MY_RESULT_NOTIFY, IDS_RESULT_INVALID_MD5, MB_ICONSTOP );
			}
			PostMessage( hDlg, WM_MY_SOCKET_NOTIFY, 0, 0 );
			pInfo->nClientState = STATE_CLIENT_NONE;
			break;
		}
	}
}

/*	WM_MY_SERVER_MSG	*/
static	void	MyServerMsgProc( HWND hDlg, int nType, int nParam )
{
	NpSftInfo	p = GetSftInfo( hDlg );
	if( p != NULL ) {
		NpMySocketInfo	pInfo = &(p->SocketInfo);
		WORD	wAns;
		switch( nType ) {
		case MSG_C2S_FILEINFO:
			wAns = MSG_S2C_NAK;
			{	/*	Ăt@CƃTCYo	*/
				NpMyClient2ServerMsg	pMsg;
				pMsg = (NpMyClient2ServerMsg)GlobalLock( pInfo->hMsgBuff );
				lstrcpy( p->szFileName, pMsg->uMsgBody.sFileInfo.szFileName );
				p->hFile = INVALID_HANDLE_VALUE;
				p->dwSizeRemain = pMsg->uMsgBody.sFileInfo.dwSizeLow;
				p->dwSizeTotal = p->dwSizeRemain;
				GlobalUnlock( pInfo->hMsgBuff );
			}
			PostMessage( hDlg, WM_MY_SOCKET_NOTIFY, 0, 0 );
			DoProgressStep( hDlg, PROGRESS_STEP_2 );
			p->nProgressPos = 0;
			{	/*	mFbZ[W	*/
				TCHAR	msg[256];
				int		len = 0;
				if( GetPeerName( pInfo, msg ) ) {
					len = lstrlen( msg );
					len += LoadString( p->hInstance, IDS_FILE_FROM, msg+len, countof(msg)-len );
				}
				LoadString( p->hInstance, IDS_FILE_INFO, msg+len, countof(msg)-len );
				MessageBox( hDlg, msg, p->szAppTitle, MB_APPLMODAL|MB_DEFBUTTON1|MB_ICONASTERISK|MB_OK );
			}
#ifdef	_DEBUG
			OutputDebugString( p->szFileName );
#endif
			/*	ۑ	*/
			if( DoFileDialog( hDlg, TRUE ) ) {
				wAns = MSG_S2C_ACK;
			}
			pInfo->dwRecvLen = 0;
			SendS2cMsg( pInfo->hSockClient, wAns );
			
			PostMessage( hDlg, WM_MY_SOCKET_NOTIFY, 0, 0 );
			break;
		case MSG_C2S_CONTENT:
			if( p->hFile == INVALID_HANDLE_VALUE ) {
				p->hFile = CreateFile( p->szSaveFilePath, GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL );
				MD5Init( &(p->md5context) );
				PostMessage( hDlg, WM_MY_SOCKET_NOTIFY, 0, 0 );
			}
			if( p->hFile != INVALID_HANDLE_VALUE ) {
				NpMyClient2ServerMsg	pMsg;
				DWORD	dwSize;
				DWORD	dwRemain;
				DWORD	dwWrite;
				
				pMsg = (NpMyClient2ServerMsg)GlobalLock( pInfo->hMsgBuff );
				
				dwRemain = dwSize = pMsg->uMsgBody.sFileContent.wSize;
				while( dwRemain > 0 ) {
					int		pos = 0;
					dwWrite = 0;
					WriteFile( p->hFile, pMsg->uMsgBody.sFileContent.data + pos, dwRemain, &dwWrite, NULL );
					if( dwRemain < dwWrite ) {
						dwRemain = 0;
					} else {
						dwRemain -= dwWrite;
						pos += dwWrite;
					}
				}
				p->dwSizeRemain -= dwSize;
				
				MD5Update( &(p->md5context), (unsigned char *)(pMsg->uMsgBody.sFileContent.data), dwSize );
				
				p->nProgressPos = SetProgressPos( hDlg, p->nProgressPos, p->dwSizeTotal, p->dwSizeRemain );
				
				GlobalUnlock( pInfo->hMsgBuff );
				pInfo->dwRecvLen = 0;
				
				SendS2cMsg( pInfo->hSockClient, MSG_S2C_ACK );
			} else {
				SendS2cMsg( pInfo->hSockClient, MSG_S2C_NAK );
				PostMessage( hDlg, WM_MY_RESULT_NOTIFY, IDS_ERROR_CREATE_FILE, MB_ICONSTOP );
			}
			break;
		case MSG_C2S_FILEATTR:
			wAns = MSG_S2C_NAK;
			if( p->hFile != INVALID_HANDLE_VALUE ) {
				/*	MD5lmF	*/
				/*	^CX^vXV	*/
				NpMyClient2ServerMsg	pMsg;
				BYTE	md5[ countof(pMsg->uMsgBody.sFileAttr.md5) ];
				
				pMsg = (NpMyClient2ServerMsg)GlobalLock( pInfo->hMsgBuff );
				
				MaxProgressPos( hDlg );
				
				MD5Final( md5, &(p->md5context) );
				
				if( MD5Compare( md5, pMsg->uMsgBody.sFileAttr.md5 ) ) {
					FILETIME	ft;
					SYSTEMTIME	st;
					
#ifdef	_DEBUG
					OutputDebugString( _T("match MD5\r\n") );
#endif
					
					st.wYear = pMsg->uMsgBody.sFileAttr.wYear;
					st.wMonth = pMsg->uMsgBody.sFileAttr.wMonth;
					st.wDayOfWeek = pMsg->uMsgBody.sFileAttr.wDayOfWeek;
					st.wDay = pMsg->uMsgBody.sFileAttr.wDay;
					st.wHour = pMsg->uMsgBody.sFileAttr.wHour;
					st.wMinute = pMsg->uMsgBody.sFileAttr.wMinute;
					st.wSecond = pMsg->uMsgBody.sFileAttr.wSecond;
					st.wMilliseconds = pMsg->uMsgBody.sFileAttr.wMilliseconds;
					
					SystemTimeToFileTime( &st, &ft );
					
					SetFileTime( p->hFile, NULL, NULL, &ft );
					
					wAns = MSG_S2C_ACK;
					PostMessage( hDlg, WM_MY_RESULT_NOTIFY, IDS_RESULT_SUCCESS, MB_ICONINFORMATION );
				} else {
					PostMessage( hDlg, WM_MY_RESULT_NOTIFY, IDS_RESULT_INVALID_MD5, MB_ICONSTOP );
				}
				
				GlobalUnlock( pInfo->hMsgBuff );
				
				CloseHandle( p->hFile );
				p->hFile = INVALID_HANDLE_VALUE;
				
				pInfo->dwRecvLen = 0;
			}
			SendS2cMsg( pInfo->hSockClient, wAns );
			PostMessage( hDlg, WM_MY_SOCKET_NOTIFY, 0, 0 );
			break;
		}
	}
}

/*	WM_MY_SOCKET_NOTIFY	*/
static	void	MySocketNotifyProc( HWND hDlg, int nType, int nParam )
{
	NpSftInfo	p = GetSftInfo( hDlg );
	if( p != NULL ) {
		NpMySocketInfo	pInfo = &(p->SocketInfo);
		EnableControl( hDlg );
	}
}


/*	WM_MY_RESULT_NOTIFY	*/
static	void	MyResultNotifyProc( HWND hDlg, int nStrID, int nStyle )
{
	NpSftInfo	p = GetSftInfo( hDlg );
	if( p != NULL ) {
		TCHAR	msg[256];
		LoadString( p->hInstance, nStrID, msg, countof(msg) );
		MessageBox( hDlg, msg, p->szAppTitle, MB_APPLMODAL|MB_DEFBUTTON1|MB_OK|nStyle );
		if( p->SocketInfo.bListen ) {
			p->nProgressPos = ResetProgressPos( hDlg );
		}
	}
}


/*	WM_DESTROY	*/
static	BOOL	DestroyProc( HWND hDlg )
{
	NpSftInfo	p = GetSftInfo( hDlg );
	if( p != NULL ) {
		if( p->hInstShlWapiDll != NULL ) {
			p->lpPathSetDlgItemPath = NULL;
			FreeLibrary( p->hInstShlWapiDll );
			p->hInstShlWapiDll = NULL;
		}
		
		/*	c[`bv	*/
		if( p->hWndToolTip != NULL ) {
			DestroyMyToolTip( p->hWndToolTip );
			p->hWndToolTip = NULL;
		}
		
		/*	bZ[WptHg	*/
		if( p->hFontMsg != NULL ) {
			DeleteObject( p->hFontMsg );
			p->hFontMsg = NULL;
		}
		
		/*		*/
		GetDlgItemText( hDlg, IDC_EDIT_SENDTO, p->SocketInfo.szSendTo, countof(p->SocketInfo.szSendTo) );
		
		/*	INIt@C̏	*/
		WriteProfile( p, p->szProfile );
		WritePrivateProfileString( NULL, NULL, NULL, p->szProfile );
		
		/*	\Pbg	*/
		CloseMySocket( hDlg, &(p->SocketInfo) );
		QuitMySocket( hDlg, &(p->SocketInfo) );
		
		LocalFree( (HLOCAL)p );
		SetSftInfo( hDlg, NULL );
	}
	PostQuitMessage( 0 );
	return TRUE;
}

/*	_CAOvV[W	*/
static	BOOL	CALLBACK	FormWndProc( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	NpSftInfo	p = GetSftInfo( hDlg );
	switch( uMsg ) {
	case WM_INITDIALOG:
		return InitDialogProc( hDlg, (HINSTANCE)lParam );
	case WM_INITMENUPOPUP:
		InitMenuPopupProc( hDlg, (HMENU)wParam, (UINT)LOWORD(lParam), (BOOL)HIWORD(lParam) );
		break;
	case WM_COMMAND:
		return CommandProc( hDlg, HIWORD(wParam), LOWORD(wParam), (HWND)lParam );
	case WM_SYSCOMMAND:
		return SysCommandProc( hDlg, (UINT)wParam, LOWORD(lParam), HIWORD(lParam) );
	case WM_NOTIFY:
		NotifyProc( hDlg, (LPNMHDR)lParam );
		break;
	case WM_MY_CLIENT_MSG:
		MyClientMsgProc( hDlg, (int)wParam, (int)lParam );
		break;
	case WM_MY_SERVER_MSG:
		MyServerMsgProc( hDlg, (int)wParam, (int)lParam );
		break;
	case WM_MY_SOCKET_NOTIFY:
		MySocketNotifyProc( hDlg, (int)wParam, (int)lParam );
		break;
	case WM_MY_RESULT_NOTIFY:
		MyResultNotifyProc( hDlg, (int)wParam, (int)lParam );
		break;
	case WM_CLOSE:
		DestroyWindow( hDlg );
		break;
	case WM_DESTROY:
		DestroyProc( hDlg );
		break;
	default:
		if( p != NULL && uMsg == p->SocketInfo.uAsyncMsg ) {
			MySockerMsgProc( hDlg, wParam, lParam, &(p->SocketInfo) );
		}
		break;
	}
	return FALSE;
}

int		WINAPI	WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int nCmdShow )
{
	MSG		msg;
	HWND	hWnd;
	
#ifdef	_DEBUG
	UINT	nMsg = RegisterWindowMessage( _T("StartDebugMonitor") );
	SendMessage( HWND_BROADCAST, nMsg, GetCurrentProcessId(), 0 );
#endif
	
	/*	tbN	*/
	InstallHook( hInstance );
	
	InitCommonControls();
	hWnd = CreateFormWnd( hInstance, MAKEINTRESOURCE( IDD_MAIN_DIALOG ), NULL );
	if( hWnd == NULL ) {
		RemoveHook();
		return 0;
	}
	ShowWindow( hWnd, SW_SHOWDEFAULT );
	UpdateWindow( hWnd );
	
	/*	\Pbg	*/
	{
		NpSftInfo	p = GetSftInfo( hWnd );
		if( !StartMySocket( hWnd, &(p->SocketInfo) ) ) {
			TCHAR	msg[80];
			LoadString( p->hInstance, IDS_ERROR_WSASTARTUP, msg, countof(msg) );
			MessageBox( hWnd, msg, p->szAppTitle, MB_APPLMODAL|MB_DEFBUTTON1|MB_ICONSTOP|MB_OK );
			PostMessage( hWnd, WM_CLOSE, 0, 0 );
		}
	}
	
	while( GetMessage( &msg, NULL, 0, 0 ) ) {
		if( !IsDialogMessage( hWnd, &msg ) ) {
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}
	}
	
	/*	tbN	*/
	RemoveHook();
	
	return (int)msg.wParam;
}
