/*--------------------------------------------------------------*\
		module	:	Tools.c
		purpose :	ȒPt@C] ec[
		author	:	_@ Kengo Jinno
		create	:	2011/03/01
		update	:	2011/04/08
\*--------------------------------------------------------------*/

#include	"PCH.h"

#include	"Tools.h"

BOOL	ScreenToClientRect( HWND hWnd, LPRECT lprect )
{
	POINT	p;
	p.x = lprect->left;
	p.y = lprect->top;
#ifdef	WIN32
	if( !ScreenToClient( hWnd, &p ) ) {
		return FALSE;
	}
#else
	ScreenToClient( hWnd, &p );
#endif
	lprect->left = p.x;
	lprect->top = p.y;
	p.x = lprect->right;
	p.y = lprect->bottom;
#ifdef	WIN32
	if( !ScreenToClient( hWnd, &p ) ) {
		return FALSE;
	}
#else
	ScreenToClient( hWnd, &p );
#endif
	lprect->right = p.x;
	lprect->bottom = p.y;
	return TRUE;
}

BOOL	ClientToScreenRect( HWND hWnd, LPRECT lprect )
{
	POINT	p;
	p.x = lprect->left;
	p.y = lprect->top;
#ifdef	WIN32
	if( !ClientToScreen( hWnd, &p ) ) {
		return FALSE;
	}
#else
	ClientToScreen( hWnd, &p );
#endif
	lprect->left = p.x;
	lprect->top = p.y;
	p.x = lprect->right;
	p.y = lprect->bottom;
#ifdef	WIN32
	if( !ClientToScreen( hWnd, &p ) ) {
		return FALSE;
	}
#else
	ClientToScreen( hWnd, &p );
#endif
	lprect->right = p.x;
	lprect->bottom = p.y;
	return TRUE;
}


/*	DLL̃o[W𒲂ׂ	*/
BOOL	GetDllVersion( LPCTSTR lpszDllName, LPDWORD lpdwFileMS, LPDWORD lpdwFileLS, LPDWORD lpdwProdMS, LPDWORD lpdwProdLS )
{
	BOOL	ret = TRUE;
	BOOL	bMustFree = FALSE;
	HINSTANCE	hInstDll = GetModuleHandle( lpszDllName );
	if( hInstDll == NULL ) {
		hInstDll = LoadLibrary( lpszDllName );
		bMustFree = TRUE;
	}
	if( hInstDll == NULL ) {
		ret = FALSE;
	} else {
		TCHAR	szPath[_MAX_PATH];
		DWORD	dwInfoSize;
		LPVOID	lpBlock = NULL;
		VS_FIXEDFILEINFO	*lpInfo;
		
		if( ret ) {
			ret = ( GetModuleFileName( hInstDll, szPath, _MAX_PATH ) != 0 );
		}
		if( ret ) {
			dwInfoSize = GetFileVersionInfoSize( szPath, NULL );
			ret = ( dwInfoSize != 0 );
		}
		if( ret ) {
			lpBlock = (LPVOID)GlobalAlloc( GPTR, sizeof(BYTE)*dwInfoSize );
			ret = ( lpBlock != NULL );
		}
		if( ret ) {
			ret = GetFileVersionInfo( szPath, 0, dwInfoSize, lpBlock );
		}
		if( ret ) {
			UINT	uLen;
			ret = VerQueryValue( lpBlock, _T("\\"), (LPVOID*)&lpInfo, &uLen );
		}
		if( ret ) {
			if( lpdwFileMS != NULL )	*lpdwFileMS = lpInfo->dwFileVersionMS;
			if( lpdwFileLS != NULL )	*lpdwFileLS = lpInfo->dwFileVersionLS;
			if( lpdwProdMS != NULL )	*lpdwProdMS = lpInfo->dwProductVersionMS;
			if( lpdwProdLS != NULL )	*lpdwProdLS = lpInfo->dwProductVersionLS;
		}
		if( lpBlock != NULL ) {
			GlobalFree( (HGLOBAL)lpBlock );
		}
		if( bMustFree ) {
			FreeLibrary( hInstDll );
		}
	}
	return ret;
}

/*	|bvAbvEBhE\Ă邩H	*/
BOOL	IsPopupWindowShown( HWND hWnd )
{
	HWND	hPopupWnd = GetLastActivePopup( hWnd );
	return( hPopupWnd != hWnd && IsWindowVisible( hPopupWnd ) );
}
