/*--------------------------------------------------------------*\
		module	:	md5.h
		purpose :	RFC1321 The MD5 Message-Digest Algorithm
		author	:	_@ Kengo Jinno
		create	:	2001/09/12
		update	:	2001/09/12
\*--------------------------------------------------------------*/

#ifndef	MD5_H
#define	MD5_H

#ifdef	__cplusplus
extern "C" {
#endif

/* POINTER defines a generic pointer type */
typedef unsigned char *POINTER;

/* UINT2 defines a two byte word */
typedef unsigned short int UINT2;

/* UINT4 defines a four byte word */
typedef unsigned long int UINT4;

/* MD5 context. */
typedef struct {
  UINT4 state[4];                                   /* state (ABCD) */
  UINT4 count[2];        /* number of bits, modulo 2^64 (lsb first) */
  unsigned char buffer[64];                         /* input buffer */
} MD5_CTX;

extern	void	MD5Init( MD5_CTX * );
extern	void	MD5Update( MD5_CTX *, unsigned char *, unsigned int );
extern	void	MD5Final( unsigned char [16], MD5_CTX * );

extern	BOOL	MD5Compare( unsigned char [16], unsigned char [16] );

#ifdef	__cplusplus
}
#endif

#endif	/*	MD5_H	*/
